Index: resources/styles/default/lines
===================================================================
--- resources/styles/default/lines	(revision 4250)
+++ resources/styles/default/lines	(working copy)
@@ -14,16 +14,16 @@
 (aeroway=taxiway | aeroway=taxilane) & highway!=* & is_closed()=false {name '${ref}'} [0x27 resolution 24]
 
 # Assign the street name for house number search
-highway=* & name=* { set mkgmap:street='${name}' }
+highway=* & name=* {set mkgmap:street='${name}'}
 
 # Mark highways with the toll flag
-highway=* & (toll=yes|toll=true) { set mkgmap:toll=yes }
+highway=* & (toll=yes|toll=true) {set mkgmap:toll=yes}
 
 # mark multipolygons as area
 highway=* & mkgmap:mp_created=true {add area=yes}
 
 # Hide proposed ways
-(highway=proposed | highway=proposal | highway=planned | highway ~ '.*proposed.*') {delete highway;delete junction}
+(highway=proposed | highway=proposal | highway=planned | highway~'.*proposed.*') {delete highway; delete junction}
 # Hide removed ways
 (highway=razed | highway=dismantled) {deletealltags}
 # Hide abandoned ways. Abandoned highways have some evidence of their former existence but are no longer used. These
@@ -31,88 +31,84 @@
 # https://wiki.openstreetmap.org/wiki/Key:abandoned:
 ((abandoned:highway=* & highway!=*) | highway=abandoned) {deletealltags}
 # Hide other non-existent ways
-(highway=unbuilt | highway=neverbuilt | highway=rejected | highway ~ 'x-.*') {delete highway;delete junction}
+(highway=unbuilt | highway=neverbuilt | highway=rejected | highway~'x-.*') {delete highway; delete junction}
 # Remove highway tag from ways which are not suitable for routing
-highway=traffic_signals | highway=junction | highway=island | highway=centre_line | highway=traffic_island | highway=stopline {delete highway} 
+highway=traffic_signals | highway=junction | highway=island | highway=centre_line | highway=traffic_island | highway=stopline
+    {delete highway}
 highway=piste | highway=ski {delete highway}
 highway=no | highway=none {delete highway}
- 
+
 # Hide unaccessible tunnels
-highway=* & tunnel=yes & (access=private|access=no)
-& foot!=* & bicycle!=* {delete highway;delete junction}
+highway=* & tunnel=yes & (access=private | access=no) & foot!=* & bicycle!=* {delete highway; delete junction}
 # Disable dead-end-checks for unaccessible oneways
-highway=* & oneway=yes & (access=private|access=no)
-{add mkgmap:dead-end-check=false}
+highway=* & oneway=yes & (access=private|access=no) {add mkgmap:dead-end-check=false}
 # Validation-like checks (uncomment to enable)
-#highway=motorway_link & oneway!=yes & oneway!=no { echo "motorway_link lacks oneway" }
-highway=motorway|highway=motorway_link { add oneway=yes; add mkgmap:numbers=false }
+#highway=motorway_link & oneway!=yes & oneway!=no {echo "motorway_link lacks oneway"}
+highway=motorway | highway=motorway_link {add oneway=yes; add mkgmap:numbers=false}
 
 # start of rules for process-exits and process-destination options
 # which may add info to a part of these highway=*_link roads:
 # motorway_link, trunk_link, primary_link, secondary_link, tertiary_link
-# build destination hint 
-mkgmap:dest_hint=*
-  { set dest_hint = '${destination:ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' |
-         '${ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' | 
-         '${mkgmap:dest_hint|subst:;=> |subst:/=> }';
-       }
-# build exit hint 
-mkgmap:exit_hint=true 
-  { set exit_hint = 'Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_name}' | 
-         'Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_exit_to}' | 
-         'Exit ${mkgmap:exit_hint_exit_to}' |
-         'Exit ${mkgmap:exit_hint_name}' |
-         'Exit ${mkgmap:exit_hint_ref}';
-       }
-  
-# use destination hint and/or exit hint to build name              
-(mkgmap:exit_hint=true | mkgmap:dest_hint=*)
-  {	name '${exit_hint} ${dest_hint}' | 	'${dest_hint}' | 		'${exit_hint}' }
+# build destination hint
+mkgmap:dest_hint=* {
+    set dest_hint='${destination:ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' |
+                  '${ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' |
+                  '${mkgmap:dest_hint|subst:;=> |subst:/=> }';
+    }
+# build exit hint
+mkgmap:exit_hint=true {
+    set exit_hint='Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_name}' |
+                  'Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_exit_to}' |
+                  'Exit ${mkgmap:exit_hint_exit_to}' |
+                  'Exit ${mkgmap:exit_hint_name}' |
+                  'Exit ${mkgmap:exit_hint_ref}';
+    }
+
+# use destination hint and/or exit hint to build name
+(mkgmap:exit_hint=true | mkgmap:dest_hint=*) {name '${exit_hint} ${dest_hint}' | '${dest_hint}' | '${exit_hint}'}
 # end of rules for process-exits and process-destination options
 
 # Flag paved roads
-highway=* & (surface=asphalt | surface=paved | surface=sett | 
-    surface=concrete | surface=concrete:lanes | surface=concrete:plates | 
-    surface=paving_stones  | surface=cobblestone  | 
-   	surface=cobblestone:flattened  | surface=metal  | surface=wood) 
-{ set mkgmap:unpaved=0 }
-highway=* & tracktype=grade1 & surface!=* { set mkgmap:unpaved=0 }
+highway=* & (surface=asphalt | surface=paved | surface=sett |
+    surface=concrete | surface=concrete:lanes | surface=concrete:plates |
+    surface=paving_stones | surface=cobblestone |
+    surface=cobblestone:flattened | surface=metal | surface=wood)
+    {set mkgmap:unpaved=0}
+highway=* & tracktype=grade1 & surface!=* {set mkgmap:unpaved=0}
 
 # Flag unpaved roads.
-highway=* & mkgmap:unpaved!=0 & (  
+highway=* & mkgmap:unpaved!=0 & (
     surface=* |
-	mtb:scale=* | 
-    tracktype ~ 'grade[2-6]')
-{ add mkgmap:unpaved=1 }
+    mtb:scale=* |
+    tracktype~'grade[2-6]')
+    {add mkgmap:unpaved=1}
 highway=* & (
-    mtb:scale ~ '[2-6].' |
-    sac_scale ~ '.*(mountain|alpine)_hiking' |
+    mtb:scale~'[2-6].' |
+    sac_scale~'.*(mountain|alpine)_hiking' |
     sport=via_ferrata)
-{ set mkgmap:unpaved=1 }
-(highway=bridleway | highway=path | highway=track) & mkgmap:unpaved!=0 { add mkgmap:unpaved=1 }
-(highway=unsurfaced | highway=via_ferrata) { set mkgmap:unpaved=1 }
+    {set mkgmap:unpaved=1}
+(highway=bridleway | highway=path | highway=track) & mkgmap:unpaved!=0 {add mkgmap:unpaved=1}
+(highway=unsurfaced | highway=via_ferrata) {set mkgmap:unpaved=1}
 
-highway=* & mkgmap:unpaved!=1 & smoothness ~ '.*(bad|horrible|impassable)'  { add mkgmap:road-speed = '-2' } 
+highway=* & mkgmap:unpaved!=1 & smoothness~'.*(bad|horrible|impassable)' {add mkgmap:road-speed='-2'}
 
 # Good ways without relation
-highway=* & mkgmap:fast_road!=* & (int_ref=* | network=e-road | network=AH | network=TAH | network=US:I | network=US:US) {add mkgmap:fast_road=yes}
+highway=* & mkgmap:fast_road!=* & (int_ref=* | network=e-road | network=AH | network=TAH | network=US:I | network=US:US)
+    {add mkgmap:fast_road=yes}
 # Not best for car routing
-highway=* & (access=hov | hov=designated | oneway=reversible) {set mkgmap:road-class=-2; set mkgmap:road-speed=-2; delete mkgmap:fast_road}
+highway=* & (access=hov | hov=designated | oneway=reversible)
+    {set mkgmap:road-class=-2; set mkgmap:road-speed=-2; delete mkgmap:fast_road}
 
 # Convert generic path to most specific
-highway=footway & snowplowing!=no
-& (bicycle=yes|bicycle=designated|bicycle=permissive|bicycle=official)
-{set highway=cycleway; set bicycle=yes; set foot=yes}
-highway=path & snowplowing!=no
-& (bicycle=designated|bicycle=permissive|bicycle=official)
-{set highway=cycleway; set bicycle=yes}
+highway=footway & snowplowing!=no & (bicycle=yes|bicycle=designated|bicycle=permissive|bicycle=official)
+    {set highway=cycleway; set bicycle=yes; set foot=yes}
+highway=path & snowplowing!=no & (bicycle=designated|bicycle=permissive|bicycle=official)
+    {set highway=cycleway; set bicycle=yes}
 highway=path & (horse=designated|horse=permissive|horse=official)
-{set highway=bridleway; set horse=yes}
+    {set highway=bridleway; set horse=yes}
 
-leisure=track & area!=yes
-{add highway=footway; name '${name} (${sport})' | '${name}'}
-(man_made=pier | man_made=piste:halfpipe) & area!=yes
-{add highway=footway; name '${ref} ${name}' | '${ref}' | '${name}' }
+leisure=track & area!=yes {add highway=footway; name '${name} (${sport})' | '${name}'}
+(man_made=pier | man_made=piste:halfpipe) & area!=yes {add highway=footway; name '${ref} ${name}' | '${ref}' | '${name}'}
 
 # Roundabouts
 junction=roundabout & (highway=trunk | highway=trunk_link) [0x0c road_class=4 road_speed=2 resolution 24 continue]
@@ -139,13 +135,12 @@
 # Ways that may or may not be useable
 
 # Treat ways under construction almost as highway=path, see also extra rule in inc/access
-highway=construction { add mkgmap:dead-end-check = false; }
-[0x16 road_class=0 road_speed=0 resolution 23]
+highway=construction {add mkgmap:dead-end-check=false} [0x16 road_class=0 road_speed=0 resolution 23]
 
 # Lower the road speed of ways under some construction.
-highway=* & construction=* & maxspeed!=* { add mkgmap:road-speed = '-1' }
+highway=* & construction=* & maxspeed!=* {add mkgmap:road-speed='-1'}
 # Lower the road speed of disused ways.
-highway=* & disused=yes & maxspeed!=* { add mkgmap:road-speed = '-2' }
+highway=* & disused=yes & maxspeed!=* {add mkgmap:road-speed='-2'}
 
 # Ways sorted roughly by descending order of class
 highway=motorway & mkgmap:fast_road=yes [0x01 road_class=4 road_speed=7 resolution 14]
@@ -181,21 +176,19 @@
 highway=bridleway [0x07 road_class=0 road_speed=0 resolution 23]
 highway=byway [0x16 road_class=0 road_speed=0 resolution 23]
 
-highway=service & service=parking_aisle
-[0x07 road_class=0 road_speed=1 resolution 24]
-highway=service & (service=alley|service=driveway)
-[0x07 road_class=0 road_speed=0 resolution 23]
+highway=service & service=parking_aisle [0x07 road_class=0 road_speed=1 resolution 24]
+highway=service & (service=alley|service=driveway) [0x07 road_class=0 road_speed=0 resolution 23]
 highway=service [0x07 road_class=0 road_speed=2 resolution 22]
 
 highway=cycleway [0x07 road_class=0 road_speed=1 resolution 23]
 
-highway=footway|highway=path|highway=steps [0x16 road_class=0 road_speed=0 resolution 23]
+highway=footway | highway=path | highway=steps [0x16 road_class=0 road_speed=0 resolution 23]
 highway=track [0x0a road_class=0 road_speed=1 resolution 22]
 highway=unsurfaced [0x0a road_class=0 road_speed=1 resolution 22]
-highway=road { add mkgmap:dead-end-check = false} [0x06 road_class=0 road_speed=1 resolution 22]
+highway=road {add mkgmap:dead-end-check=false} [0x06 road_class=0 road_speed=1 resolution 22]
 
 # Mop up any unrecognised highway types
-highway=* & area!=yes [0x07 road_class=0 road_speed=0 resolution 23] 
+highway=* & area!=yes [0x07 road_class=0 road_speed=0 resolution 23]
 
 natural=coastline [0x15 resolution 12]
 power=line [0x29 resolution 21]
@@ -202,17 +195,16 @@
 
 railway=abandoned [0x0a road_class=0 road_speed=1 resolution 22]
 railway=platform [0x16 road_class=0 road_speed=0 resolution 23]
-# Railway lines, note that many devices display type 0x14 only at resolution 24 
-(railway=rail | railway=tram | railway=disused | railway=subway | railway=narrow_gauge | railway=light_rail | railway=preserved) & !(tunnel=yes) [0x14 resolution 22]
+# Railway lines, note that many devices display type 0x14 only at resolution 24
+(railway=rail | railway=tram | railway=disused | railway=subway | railway=narrow_gauge | railway=light_rail | railway=preserved) & !(tunnel=yes)
+    [0x14 resolution 22]
 
-(man_made=cable|(man_made=* & man_made ~ '.*pipe.*')) & area!=yes &
-tunnel!=yes & location != underground
-{name '${name} (${operator})' | '${name}' | '${operator}' }
-[0x28 resolution 23]
+(man_made=cable | (man_made=* & man_made~'.*pipe.*')) & area!=yes & tunnel!=yes & location!=underground
+    {name '${name} (${operator})' | '${name}' | '${operator}'} [0x28 resolution 23]
 
 # The following boundary styles are after the highway rules because ways
 # are frequently tagged with both and we want the highway to take priority.
-boundary=administrative { name '${mkgmap:boundary_name}' }
+boundary=administrative {name '${mkgmap:boundary_name}'}
 boundary=administrative & admin_level<3 [0x1e resolution 12]
 boundary=administrative & admin_level<5 [0x1d resolution 19]
 boundary=administrative & admin_level<7 [0x1c resolution 21]
@@ -221,7 +213,7 @@
 boundary=national [0x1e resolution 17]
 boundary=political [0x1c resolution 19]
 
-route=ferry {set mkgmap:numbers = false }
+route=ferry {set mkgmap:numbers=false}
 route=ferry & (motorcar=no | motor_vehicle=no) {add mkgmap:ferry=1} [0x1b road_class=0 road_speed=0 resolution 23]
 route=ferry {add mkgmap:ferry=1} [0x1b road_class=3 road_speed=0 resolution 19]
 
@@ -240,24 +232,25 @@
 
 include 'inc/address';
 # calculate the road speed based on maxspeed tag
-include 'inc/roadspeed'; 
+include 'inc/roadspeed';
 # calculate the access rules
 include 'inc/access';
 
 #limit artificial cycleways to resolution 24
-mkgmap:synthesised=yes & mkgmap:bicycle=yes { set mkgmap:highest-resolution-only = true }
+mkgmap:synthesised=yes & mkgmap:bicycle=yes {set mkgmap:highest-resolution-only=true}
 
 # don't add house numbers to unnamed or artifical bicycle ways
 mkgmap:bicycle=yes & (mkgmap:foot=no & mkgmap:car=no & mkgmap:street!=* | mkgmap:synthesised=yes) {set mkgmap:numbers=false}
 
 # Display highway shield for mayor roads if they have a ref and make them searchable by their name
-(highway=motorway | highway=trunk) & ref=* { name '${ref|highway-symbol:hbox}'; addlabel '${name}' }
-highway=primary & ref=* { name  '${ref|highway-symbol:box}'; addlabel '${name}' }
-(highway=secondary | highway=tertiary) & ref=* { name '${ref|highway-symbol:oval}'; addlabel '${name}' }
+(highway=motorway | highway=trunk) & ref=* {name '${ref|highway-symbol:hbox}'; addlabel '${name}'}
+highway=primary & ref=* {name '${ref|highway-symbol:box}'; addlabel '${name}'}
+(highway=secondary | highway=tertiary) & ref=* {name '${ref|highway-symbol:oval}'; addlabel '${name}'}
 
-name=* { name '${name}' }
-highway=* & ref=* & highway!=motorway & highway!=trunk & highway!=primary & highway!=secondary & highway!=tertiary { addlabel '${ref}' }
+name=* {name '${name}'}
+highway=* & ref=* & highway!=motorway & highway!=trunk & highway!=primary & highway!=secondary & highway!=tertiary
+    {addlabel '${ref}'}
 
-highway=* & int_ref=* { addlabel '${int_ref}' }
-highway=* & nat_ref=* { addlabel '${nat_ref}' }
-highway=* & reg_ref=* { addlabel '${reg_ref}' }
+highway=* & int_ref=* {addlabel '${int_ref}'}
+highway=* & nat_ref=* {addlabel '${nat_ref}'}
+highway=* & reg_ref=* {addlabel '${reg_ref}'}
Index: resources/styles/default/points
===================================================================
--- resources/styles/default/points	(revision 4250)
+++ resources/styles/default/points	(working copy)
@@ -9,87 +9,85 @@
 # for more information.
 
 addr:housenumber=* {set mkgmap:execute_finalize_rules=true}
-barrier=* & bicycle=*    { set mkgmap:bicycle='${bicycle|subst:private=>no}' }
-barrier=* & foot=*       { set mkgmap:foot='${foot|subst:private=>no}' }                  
-barrier=* & hgv=*        { set mkgmap:truck='${hgv|subst:private=>no}' }                  
-barrier=* & motorcar=*   { set mkgmap:car='${motorcar|subst:private=>no}' }
-barrier=* & psv=*        { set mkgmap:bus='${psv|subst:private=>no}' }                  
-barrier=* & taxi=*       { set mkgmap:taxi='${taxi|subst:private=>no}' }                  
-barrier=* & emergency=*  { set mkgmap:emergency='${emergency|subst:private=>no}' }                  
-barrier=* & delivery=*   { set mkgmap:delivery='${delivery|subst:private=>no}' }                  
-barrier=* & access=*     { addaccess '${access|subst:private=>no}' }
 
-barrier=bollard | barrier=cycle_barrier 
-    { add mkgmap:bicycle=yes; 
-      add mkgmap:foot=yes; 
-      addaccess no;
-      set mkgmap:road-speed=1; }
-barrier=bus_trap  
-    { add mkgmap:bus=yes; 
-      add mkgmap:foot=yes; 
-      add mkgmap:bicycle=yes; 
-      addaccess no;
-      set mkgmap:road-speed=1; }
-barrier=gate
-    { add mkgmap:bicycle=yes; 
-      add mkgmap:foot=yes; 
-      addaccess no;
-      set mkgmap:road-speed=0; }
-barrier=kissing_gate | barrier=stile | barrier=block
-    { add mkgmap:foot=yes; 
-      addaccess no;
-      set mkgmap:road-speed=0; }
+barrier=* & bicycle=*   {set mkgmap:bicycle  =  '${bicycle|subst:private=>no}'}
+barrier=* & foot=*      {set mkgmap:foot     =     '${foot|subst:private=>no}'}
+barrier=* & hgv=*       {set mkgmap:truck    =      '${hgv|subst:private=>no}'}
+barrier=* & motorcar=*  {set mkgmap:car      = '${motorcar|subst:private=>no}'}
+barrier=* & psv=*       {set mkgmap:bus      =      '${psv|subst:private=>no}'}
+barrier=* & taxi=*      {set mkgmap:taxi     =     '${taxi|subst:private=>no}'}
+barrier=* & emergency=* {set mkgmap:emergency='${emergency|subst:private=>no}'}
+barrier=* & delivery=*  {set mkgmap:delivery = '${delivery|subst:private=>no}'}
+barrier=* & access=*    {addaccess               '${access|subst:private=>no}'}
 
-internet_access=yes { name 'Internet ${name}' | 'Internet' } [0x2f12 resolution 24 continue]
-internet_access=* & internet_access!=no & internet_access!=yes { name 'Internet(${internet_access}) ${name|def:}' } [0x2f12 resolution 24 continue]
+barrier=bollard | barrier=cycle_barrier {
+    add mkgmap:bicycle=yes;
+    add mkgmap:foot=yes;
+    addaccess no;
+    set mkgmap:road-speed=1;
+    }
+barrier=bus_trap {
+    add mkgmap:bus=yes;
+    add mkgmap:foot=yes;
+    add mkgmap:bicycle=yes;
+    addaccess no;
+    set mkgmap:road-speed=1;
+    }
+barrier=gate {
+    add mkgmap:bicycle=yes;
+    add mkgmap:foot=yes;
+    addaccess no;
+    set mkgmap:road-speed=0;
+    }
+barrier=kissing_gate | barrier=stile | barrier=block {
+    add mkgmap:foot=yes;
+    addaccess no;
+    set mkgmap:road-speed=0;
+    }
 
+internet_access=yes {name 'Internet ${name}' | 'Internet'} [0x2f12 resolution 24 continue]
+internet_access=* & internet_access!=no & internet_access!=yes {name 'Internet(${internet_access}) ${name|def:}'} [0x2f12 resolution 24 continue]
+
 (public_transport=platform | highway=bus_stop | railway=tram_stop | railway=halt | railway=station)
-& (ref=* | route_ref=*) {
-  set ref='${ref|def:}(${route_ref})';
-}
+    & (ref=* | route_ref=*)
+    {set ref='${ref|def:}(${route_ref})'}
 (public_transport=platform | highway=bus_stop | railway=tram_stop | railway=halt | railway=station)
-& lit=yes & (shelter=yes | covered=yes)
-{
-  set ref='${ref|def:}*';
-}
+    & lit=yes & (shelter=yes | covered=yes)
+    {set ref='${ref|def:}*'}
 (public_transport=platform | highway=bus_stop | railway=tram_stop | railway=halt | railway=station)
-& lit!=yes & (shelter=yes | covered=yes)
-{
-  set ref='${ref|def:}+';
-}
+    & lit!=yes & (shelter=yes | covered=yes)
+    {set ref='${ref|def:}+'}
 (public_transport=platform | highway=bus_stop | railway=tram_stop | railway=halt | railway=station)
-& (shelter=no | covered=no)
-{
-  set ref='${ref|def:}-';
-}
+    & (shelter=no | covered=no)
+    {set ref='${ref|def:}-'}
 
 include 'inc/name';
 
-place=city & population > 999999 & name=*  {set cityxx=yes} [0x0100 resolution 12 continue with_actions]
-place=city & population > 799999 & cityxx!=yes & name=*  {set cityxx=yes} [0x0200 resolution 14 continue with_actions]
-place=city & population > 399999 & cityxx!=yes & name=*  {set cityxx=yes} [0x0300 resolution 15 continue with_actions]
-place=city & population > 299999 & cityxx!=yes & name=*  {set cityxx=yes} [0x0400 resolution 16 continue with_actions]
-place=city & population > 199999 & cityxx!=yes & name=*  {set cityxx=yes} [0x0500 resolution 16 continue with_actions]
-place=city & population >  99999 & cityxx!=yes & name=*  {set cityxx=yes} [0x0600 resolution 17 continue with_actions]
-place=city & population >  49999 & cityxx!=yes & name=*  {set cityxx=yes} [0x0700 resolution 17 continue with_actions]
-place=city & population >   9999 & cityxx!=yes & name=*  {set cityxx=yes} [0x0800 resolution 18 continue with_actions]
+place=city & population > 999999 &               name=* {set cityxx=yes} [0x0100 resolution 12 continue with_actions]
+place=city & population > 799999 & cityxx!=yes & name=* {set cityxx=yes} [0x0200 resolution 14 continue with_actions]
+place=city & population > 399999 & cityxx!=yes & name=* {set cityxx=yes} [0x0300 resolution 15 continue with_actions]
+place=city & population > 299999 & cityxx!=yes & name=* {set cityxx=yes} [0x0400 resolution 16 continue with_actions]
+place=city & population > 199999 & cityxx!=yes & name=* {set cityxx=yes} [0x0500 resolution 16 continue with_actions]
+place=city & population >  99999 & cityxx!=yes & name=* {set cityxx=yes} [0x0600 resolution 17 continue with_actions]
+place=city & population >  49999 & cityxx!=yes & name=* {set cityxx=yes} [0x0700 resolution 17 continue with_actions]
+place=city & population >   9999 & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 18 continue with_actions]
 
-place=city & population >       0 & cityxx!=yes & name=*  {set cityxx=yes} [0x0800 resolution 18 continue with_actions]
-place=city                          & cityxx!=yes & name=*  {set cityxx=yes} [0x0700 resolution 18 continue with_actions]
+place=city & population >      0 & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 18 continue with_actions]
+place=city                       & cityxx!=yes & name=* {set cityxx=yes} [0x0700 resolution 18 continue with_actions]
 
-place=town   & population >  69999 & cityxx!=yes  & name=* {set cityxx=yes} [0x0600 resolution 17 continue with_actions]
-place=town   & population >  19999 & cityxx!=yes  & name=* {set cityxx=yes} [0x0700 resolution 18 continue with_actions]
-place=town   & population >   9999 & cityxx!=yes  & name=* {set cityxx=yes} [0x0800 resolution 19 continue with_actions]
-place=town   & population >   4999 & cityxx!=yes  & name=* {set cityxx=yes} [0x0900 resolution 19 continue with_actions]
-place=town   & population >    999 & cityxx!=yes  & name=* {set cityxx=yes} [0x0a00 resolution 19 continue with_actions]
-place=town   & population >         0 & cityxx!=yes  & name=* {set cityxx=yes} [0x0b00 resolution 20 continue with_actions]
-place=town                            & cityxx!=yes  & name=* {set cityxx=yes} [0x0800 resolution 19 continue with_actions]
+place=town & population >  69999 & cityxx!=yes & name=* {set cityxx=yes} [0x0600 resolution 17 continue with_actions]
+place=town & population >  19999 & cityxx!=yes & name=* {set cityxx=yes} [0x0700 resolution 18 continue with_actions]
+place=town & population >   9999 & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 19 continue with_actions]
+place=town & population >   4999 & cityxx!=yes & name=* {set cityxx=yes} [0x0900 resolution 19 continue with_actions]
+place=town & population >    999 & cityxx!=yes & name=* {set cityxx=yes} [0x0a00 resolution 19 continue with_actions]
+place=town & population >      0 & cityxx!=yes & name=* {set cityxx=yes} [0x0b00 resolution 20 continue with_actions]
+place=town                       & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 19 continue with_actions]
 
-place=island & cityxx!=yes  {set cityxx=yes}	[0x650c resolution 20 continue with_actions]
-place=islet & cityxx!=yes   {set cityxx=yes}	[0x650c resolution 22 continue with_actions]
-place=village & cityxx!=yes {set cityxx=yes} 	[0x0900 resolution 22 continue with_actions]
-place=suburb & cityxx!=yes  {set cityxx=yes}	[0x0a00 resolution 22 continue with_actions]
-place=hamlet & cityxx!=yes  {set cityxx=yes}	[0x0b00 resolution 24 continue with_actions]
+place=island                     & cityxx!=yes          {set cityxx=yes} [0x650c resolution 20 continue with_actions]
+place=islet                      & cityxx!=yes          {set cityxx=yes} [0x650c resolution 22 continue with_actions]
+place=village                    & cityxx!=yes          {set cityxx=yes} [0x0900 resolution 22 continue with_actions]
+place=suburb                     & cityxx!=yes          {set cityxx=yes} [0x0a00 resolution 22 continue with_actions]
+place=hamlet                     & cityxx!=yes          {set cityxx=yes} [0x0b00 resolution 24 continue with_actions]
 
 #aeroway=airport [0x5900 resolution 22]
 aeroway=airport [0x2f04 resolution 22]
@@ -119,7 +117,7 @@
 amenity=community_center [0x3005 resolution 24]
 amenity=courthouse [0x3004 resolution 24]
 amenity=drinking_water [0x5000 resolution 24 default_name 'Water']
-amenity=embassy & country=* { set name='${country} ${name|def:}' } [0x3003 resolution 24]
+amenity=embassy & country=* {set name='${country} ${name|def:}'} [0x3003 resolution 24]
 amenity=embassy & country!=* [0x3003 resolution 24 default_name 'Embassy']
 amenity=emergency_phone [0x2f12 resolution 24 default_name 'Emergency Phone']
 amenity=ferry_terminal [0x2f08 resolution 22]
@@ -128,8 +126,8 @@
 amenity=fast_food [0x2a07 resolution 24]
 amenity=fire_station [0x3008 resolution 24]
 amenity=food_court [0x2a13 resolution 24]
-amenity=fuel & fuel:HGV_diesel=yes [ 0x2f16 resolution 23]
-amenity=fuel & shop=convenience [ 0x2e06 resolution 24]
+amenity=fuel & fuel:HGV_diesel=yes [0x2f16 resolution 23]
+amenity=fuel & shop=convenience [0x2e06 resolution 24]
 amenity=fuel [0x2f01 resolution 24]
 amenity=kindergarten [0x2c05 resolution 24]
 amenity=library [0x2c03 resolution 24]
@@ -160,7 +158,7 @@
 amenity=restaurant & cuisine=japanese [0x2a02 resolution 24]
 amenity=restaurant & cuisine=korean [0x2a02 resolution 24]
 amenity=restaurant & cuisine=mexican [0x2a09 resolution 24]
-amenity=restaurant & cuisine ~ '.*pizza.*' [0x2a0a resolution 24]
+amenity=restaurant & cuisine~'.*pizza.*' [0x2a0a resolution 24]
 amenity=restaurant & cuisine=sea_food [0x2a0b resolution 24]
 amenity=restaurant & cuisine=spanish [0x2a09 resolution 24]
 amenity=restaurant & cuisine=speciality [0x2a12 resolution 24]
@@ -179,7 +177,7 @@
 amenity=telephone [0x2f12 resolution 24 default_name 'Telephone']
 amenity=theatre [0x2d01 resolution 24]
 amenity=toilets & highway=rest_area [0x2f0c resolution 24]
-amenity=toilets [0x4e00 resolution 24 default_name 'Toilets' ]
+amenity=toilets [0x4e00 resolution 24 default_name 'Toilets']
 amenity=townhall [0x3003 resolution 24]
 amenity=university [0x2c05 resolution 24]
 # amenity=zoo is superceded by tourism=zoo
@@ -206,26 +204,26 @@
 leisure=marina [0x4300 resolution 24]
 leisure=nature_reserve & name=* [0x6612 resolution 24]
 leisure=park [0x2c06 resolution 24]
-leisure=pitch { name '${name} (${sport})' | '${name}' } [0x2c08 resolution 24]
+leisure=pitch {name '${name} (${sport})' | '${name}'} [0x2c08 resolution 24]
 leisure=playground [0x2c06 resolution 24]
 leisure=recreation_ground [0x2c08 resolution 24]
-leisure=sports_center | leisure=sports_centre { name '${name} (${sport})' | '${name}' } [0x2d0a resolution 24]
-leisure=stadium { name '${name} (${sport})' | '${name}' } [0x2c08 resolution 24]
-leisure=track { name '${name} (${sport})' | '${name}' } [0x2c08 resolution 24]
+leisure=sports_center | leisure=sports_centre {name '${name} (${sport})' | '${name}'} [0x2d0a resolution 24]
+leisure=stadium {name '${name} (${sport})' | '${name}'} [0x2c08 resolution 24]
+leisure=track {name '${name} (${sport})' | '${name}'} [0x2c08 resolution 24]
 leisure=water_park [0x2d09 resolution 24]
 
-man_made=tower|man_made=mast|landmark=chimney [0x6411 resolution 24]
+man_made=tower | man_made=mast | landmark=chimney [0x6411 resolution 24]
 
 # Edge 705 displays 0x650a,0x6511,0x6512,0x6513,0x6603,0x6614 as hollow white circles, no menu
 natural=cave_entrance [0x6601 resolution 24]
 natural=cape [0x6606 resolution 24]
 natural=cliff [0x6607 resolution 24]
-natural=peak {name '${name|def:}${ele|height:m=>ft|def:}' } [0x6616 resolution 24]
+natural=peak {name '${name|def:}${ele|height:m=>ft|def:}'} [0x6616 resolution 24]
 natural=rock [0x6614 resolution 24]
 natural=volcano [0x2c0c resolution 24]
 
 railway=station [0x2f08 resolution 22]
-( public_transport=platform & rail=yes ) | railway=halt [0x2f08 resolution 23]
+(public_transport=platform & rail=yes) | railway=halt [0x2f08 resolution 23]
 public_transport=platform | highway=bus_stop | railway=tram_stop [0x2f17 resolution 24]
 
 shop=bakers [0x2e02 resolution 24]
@@ -304,10 +302,11 @@
 natural=waterfall | waterway=waterfall [0x6508 resolution 24]
 natural=wetland & name=* [0x6513 resolution 24]
 
-landuse=cemetery|landuse=cemetary|amenity=grave_yard [0x6403 resolution 24]
-(landuse=wood|landuse=forest|natural=wood) & name=* [0x6618 resolution 24]
+landuse=cemetery | landuse=cemetary | amenity=grave_yard [0x6403 resolution 24]
+(landuse=wood | landuse=forest | natural=wood) & name=* [0x6618 resolution 24]
 
 <finalize>
 # The finalizer section is executed for each element when a rule with an element type matches
-name=* { name '${name}' }
+
+name=* {name '${name}'}
 include 'inc/address';
Index: resources/styles/default/polygons
===================================================================
--- resources/styles/default/polygons	(revision 4250)
+++ resources/styles/default/polygons	(working copy)
@@ -10,8 +10,8 @@
 
 addr:housenumber=* {set mkgmap:execute_finalize_rules=true}
 
-leisure=* & sport=* & name=* { set name='${name} (${sport})' }
-leisure=* & sport=* & name!=* { add name='${sport}' }
+leisure=* & sport=* & name=* {set name='${name} (${sport})'}
+leisure=* & sport=* & name!=* {add name='${sport}'}
 
 include 'inc/name';
 
@@ -34,8 +34,7 @@
 amenity=university [0x0a resolution 21]
 
 healthcare=hospital | amenity=hospital | amenity=clinic [0x0b resolution 22]
-healthcare=* | amenity=dentist | amenity=doctors | amenity=nursing_home
-[0x0b resolution 23]
+healthcare=* | amenity=dentist | amenity=doctors | amenity=nursing_home [0x0b resolution 23]
 
 leisure=common [0x17 resolution 21]
 leisure=garden [0x17 resolution 21]
@@ -73,7 +72,7 @@
 natural=wetland [0x51 resolution 20]
 natural=water [0x3c resolution 18]
 natural=waterfall | waterway=waterfall [0x47 resolution 21]
-natural=sea { add mkgmap:skipSizeFilter=true; set mkgmap:drawLevel=2 } [0x32 resolution 10]
+natural=sea {add mkgmap:skipSizeFilter=true; set mkgmap:drawLevel=2} [0x32 resolution 10]
 
 waterway=riverbank [0x46 resolution 20]
 
@@ -109,17 +108,14 @@
 (building=* | amenity=*) & area!=no & amenity!=grave_yard [0x13 resolution 24]
 tourism=* & area!=no & waterway!=* [0x1f resolution 24]
 # man_made can be used on areas or lines
-man_made=* & area!=no
-& (man_made!=door & man_made!=embankment & man_made!=breakwater
-   & man_made!=cable_line & man_made!=cutline & man_made!=cutting
-   & man_made!=levee & man_made!=trench
-   & man_made!=groyne & man_made!=reinforced_slope)
-[0x13 resolution 24]
+man_made=* & area!=no & (
+    man_made!=door & man_made!=embankment & man_made!=breakwater & man_made!=cable_line & man_made!=cutline &
+    man_made!=cutting & man_made!=levee & man_made!=trench & man_made!=groyne & man_made!=reinforced_slope)
+    [0x13 resolution 24]
 
-man_made=* & area=yes
-[0x13 resolution 24]
+man_made=* & area=yes [0x13 resolution 24]
 
-# render small named islands 
+# render small named islands
 place=island & name=* & area_size() < 1000000 [0x53 resolution 19]
 place=islet & name=* [0x53 resolution 20]
 
@@ -129,4 +125,4 @@
 # we need addrees info from buildings for the address search
 include 'inc/address';
 
-name=* { name '${name}' }
+name=* {name '${name}'}